package serp.app;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.SQLSyntaxErrorException;
import java.sql.Statement;
import java.sql.ResultSetMetaData;
import java.util.ArrayList;
import java.util.Properties;

import serp.Serp;
import serp.ui.Server_gui;


public class serpProtocol {
	private static Connection conn = null;
	private static Statement stmt = null;
	
	public serpProtocol(){
		createConnection();
	}
	
    public Object processInput(Object theInput) {
        Object theOutput = null;
        ResultSet result = null;
        if (((String) theInput).startsWith("Login:"))
        {
        	theOutput="Invalid";
        	String[] temp = ((String)theInput).split("Login:");
        	if (temp.length == 2)
        	{
        		temp = temp[1].split("/");
        		String username = temp[0];
        		String password = temp[1];
        		result = (ResultSet) queryDb("SELECT * FROM serp.Login WHERE username='"+username+"' and password='"+password+"'");
        		try {
					if (result.next())
						theOutput="Ok";
				} catch (SQLException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
        	}
        	
        }

        else if (((String) theInput).startsWith("Query:"))
        {
        	String[] temp = ((String)theInput).split("Query:");
        	if (temp.length == 2)
        	{
        		String query = temp[1];
        		if (query.startsWith("SELECT")){
        			result = (ResultSet) queryDb(query);
        			if (result != null)
        				theOutput = Map(result);
        		}
        		else
        			theOutput = (Integer) queryDb(query);
        	}
        }
        else if (((String) theInput).startsWith("COMMIT")){
        	try {
				conn.commit();
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
        }
        else if (((String) theInput).startsWith("ROLLBACK")){
        	try {
				conn.rollback();
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
        }
        else if (((String) theInput).startsWith("RESTORE:")){
        	String[] temp = ((String)theInput).split("RESTORE:");
        	theOutput = "Fail";
        	if (temp.length == 2)
        	{
        		String path = temp[1];
                try {
                	stmt.close();
                	conn.close();
                    conn = DriverManager.getConnection("jdbc:derby:MyDB;user=serp;password=1234;shutdown=true");
				} catch (SQLException e) {
					// TODO Auto-generated catch block
					if (e.getSQLState().equals("08006")){
						try {
							conn = DriverManager.getConnection("jdbc:derby:MyDB;user=serp;password=1234;restoreFrom="+path);
							theOutput = "Done!";
						} catch (SQLException ex) {
							// TODO Auto-generated catch block
							ex.printStackTrace();
						}
					}
					else
						e.printStackTrace();
				}
                try{
	                if (conn != null)
	                	conn.close();  
					conn = DriverManager.getConnection("jdbc:derby:MyDB;user=serp;password=1234");
					conn.setAutoCommit(false);
                } catch (SQLException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
				}

        	}
        	else
        		theOutput = "Fail: Path missing.";
        }
        try {
			stmt.close();
			if (result != null)
				result.close();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
        return theOutput;
    }
       
    private static void createConnection()
    {
        try
        {
            Class.forName("org.apache.derby.jdbc.EmbeddedDriver").newInstance();
            //Get a connection
            conn = DriverManager.getConnection("jdbc:derby:MyDB;user=serp;password=1234");
            conn.setAutoCommit(false);
        }
        catch (SQLException except)
        {
        	// Database doesn't exist yet
			if (except.getSQLState().equals("XJ004"))
				Initialize_Database();
			else
				System.out.println("serpProtocol - createConnection 1\n");
        } catch (InstantiationException e) {
			// TODO Auto-generated catch block
           	System.out.println("serpProtocol - createConnection 2\n");
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			// TODO Auto-generated catch block
		   	System.out.println("serpProtocol - createConnection 3\n");
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
		   	System.out.println("serpProtocol - createConnection 4\n");
			e.printStackTrace();
		}
    }
    
    private static Object queryDb(String query)
    {
    	Object results = null;
        try
        {
            stmt = conn.createStatement();
            if (query.startsWith("SELECT"))
            	results = stmt.executeQuery(query);
            else
            	results= stmt.executeUpdate(query);
        }
        catch (SQLException sqlExcept)
        {
        	System.out.println("-- SQLException @ queryDb @ serpProtocol");
            sqlExcept.printStackTrace();
        }
        return results;
    }
    
    private static ArrayList<ArrayList<Object>> Map(ResultSet resultset){
    	ArrayList<ArrayList<Object>> res = new ArrayList<ArrayList<Object>>();
    	try {
			while(resultset.next())
			{
	    		ResultSetMetaData metadata = resultset.getMetaData();
	    		int numcol = metadata.getColumnCount();
	    		ArrayList<Object> temp = new ArrayList<Object>();
	    		for (int i=1; i <= numcol; i++){
	    			temp.add(resultset.getObject(i));
	    		}
				res.add(temp);
			}
			resultset.close();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
    	return res;
    }
    
    public static void Close_Connection(){
    	try {
    		if (conn != null){
    			conn.close();
                conn = DriverManager.getConnection("jdbc:derby:MyDB;user=serp;password=1234;shutdown=true");
    		}
		} catch (SQLException e) {
			if (e.getSQLState().equals("08006"))
				return;
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
    }
    
    public static void Initialize_Database(){
        try {
			conn = DriverManager.getConnection("jdbc:derby:MyDB;create=true;user=serp;password=1234");
            queryDb("CREATE SCHEMA SERP");
            queryDb("CREATE TABLE SERP.LOGIN (USERNAME VARCHAR(255) NOT NULL,PASSWORD VARCHAR(255),PRIMARY KEY(USERNAME))");
            queryDb("CREATE TABLE SERP.Clients (id int NOT NULL,fname VARCHAR(255),lname VARCHAR(255),address VARCHAR(255),email VARCHAR(255),company VARCHAR(255),PRIMARY KEY(id))");
            queryDb("CREATE TABLE SERP.PRODUCTS (ID INT NOT NULL,NAME VARCHAR(255),MODEL VARCHAR(255),SN VARCHAR(255),PRICE DECIMAL(9,2),STOCK INT,PRIMARY KEY(ID))");
            queryDb("CREATE TABLE SERP.BUDGETS(ID INT NOT NULL,CLIENT INT NOT NULL,SALE INT,PRIMARY KEY(ID),FOREIGN KEY(CLIENT) REFERENCES CLIENTS(ID))");
            queryDb("CREATE TABLE SERP.BUDGET_PRODUCTS(ID INT NOT NULL,BUDGET INT NOT NULL,PRODUCT INT NOT NULL,PPU DECIMAL NOT NULL,UNITS INT NOT NULL,DISC DECIMAL NOT NULL,PRIMARY KEY(ID),FOREIGN KEY(BUDGET) REFERENCES BUDGETS(ID),FOREIGN KEY(PRODUCT) REFERENCES PRODUCTS(ID))");
            queryDb("CREATE TABLE SERP.SALES(ID INT NOT NULL,CLIENT INT NOT NULL,BUDGET INT,PRIMARY KEY(ID),FOREIGN KEY(CLIENT) REFERENCES CLIENTS(ID),FOREIGN KEY(BUDGET) REFERENCES BUDGETS(ID))");
            queryDb("CREATE TABLE SERP.SALE_PRODUCTS(ID INT NOT NULL,SALE INT NOT NULL,PRODUCT INT NOT NULL,PPU DECIMAL NOT NULL,UNITS INT NOT NULL,DISC DECIMAL NOT NULL,PRIMARY KEY(ID),FOREIGN KEY(SALE) REFERENCES SALES(ID),FOREIGN KEY(PRODUCT) REFERENCES PRODUCTS(ID))");
            queryDb("ALTER TABLE SERP.BUDGETS ADD FOREIGN KEY(SALE) REFERENCES SALES(ID)");
            queryDb("CREATE TABLE SERP.SUPPLIERS (id int NOT NULL,fname VARCHAR(255),lname VARCHAR(255),address VARCHAR(255),email VARCHAR(255),company VARCHAR(255),PRIMARY KEY(id))");
            queryDb("CREATE TABLE SERP.PURCHASES(ID INT NOT NULL,SUPPLIER INT NOT NULL,PRIMARY KEY(ID),FOREIGN KEY(SUPPLIER) REFERENCES SUPPLIERS(ID))");
            queryDb("CREATE TABLE SERP.PURCHASE_PRODUCTS(ID INT NOT NULL,PURCHASE INT NOT NULL,PRODUCT INT NOT NULL,PPU DECIMAL NOT NULL,UNITS INT NOT NULL,PRIMARY KEY(ID),FOREIGN KEY(PURCHASE) REFERENCES PURCHASES(ID),FOREIGN KEY(PRODUCT) REFERENCES PRODUCTS(ID))");
            queryDb("CREATE TABLE SERP.DISCOUNTS(ID INT NOT NULL,NAME VARCHAR (255),AMOUNT DECIMAL NOT NULL,PRIMARY KEY(ID))");
            queryDb("CREATE TABLE SERP.DISCOUNT_PRODUCTS(ID INT NOT NULL,DISCOUNT INT NOT NULL,PRODUCT INT NOT NULL,UNITS INT NOT NULL,PRIMARY KEY(ID),FOREIGN KEY(DISCOUNT) REFERENCES DISCOUNTS(ID),FOREIGN KEY(PRODUCT) REFERENCES PRODUCTS(ID))");
            queryDb("CREATE TABLE SERP.CONFIG(COMPANY VARCHAR(255),TELEPHONE VARCHAR(255),EMAIL VARCHAR(255),ADDRESS VARCHAR(255))");
            queryDb("CREATE TABLE SERP.BUDGET_DISCOUNTS(ID INT NOT NULL, BUDGET INT NOT NULL, DISCOUNT INT NOT NULL, AMOUNT DECIMAL NOT NULL, UNITS INT NOT NULL, SUBTOTAL DECIMAL NOT NULL,PRIMARY KEY(ID), FOREIGN KEY(BUDGET) REFERENCES BUDGETS(ID),FOREIGN KEY(DISCOUNT) REFERENCES DISCOUNTS(ID))");
            queryDb("CREATE TABLE SERP.SALE_DISCOUNTS(ID INT NOT NULL, SALE INT NOT NULL, DISCOUNT INT NOT NULL, AMOUNT DECIMAL NOT NULL, UNITS INT NOT NULL, SUBTOTAL DECIMAL NOT NULL,PRIMARY KEY(ID), FOREIGN KEY(SALE) REFERENCES SALES(ID),FOREIGN KEY(DISCOUNT) REFERENCES DISCOUNTS(ID))");
            queryDb("INSERT INTO LOGIN VALUES ('root','1234')");
            conn.setAutoCommit(false);
		} catch (SQLException e) {
			// TODO Auto-generated catch block
           	System.out.println("serpProtocol - Initialize_Database\n");
			e.printStackTrace();
		}
    }
    	
    }

