package serpc;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.Socket;
import java.net.UnknownHostException;
import javax.swing.JFrame;
import javax.swing.JOptionPane;

import serpc.ui.Login_gui;
import serpc.ui.Main_gui;
import serpc.ui.Main_root_gui;

public class Serpc {

	/**
	 * @param args
	 */
	private static Login_gui login;
	private static JFrame main;
	private static Socket socket;
	private static ObjectOutputStream out;
	private static ObjectInputStream in;
	
	public Serpc(){
		login = new Login_gui(this);
		login.setVisible(true);
	}

	public void check_login(String user, String pass, String server, int port){
		try {
			socket = new Socket(server,port);
			out = new
		            ObjectOutputStream(socket.getOutputStream());
			in = new 
					ObjectInputStream(socket.getInputStream());

			String msg = "Login:"+user+"/"+pass;
				
		    out.writeObject(msg);
		    String input = (String) in.readObject();
		    if (input != null){
		    	if (input.equals("Ok"))
		    	{
		    		out.writeObject("COMMIT");
		    		in.readObject();
		    		login.setVisible(false);
		    		if (user.equals("root"))
		    			main = new Main_root_gui(this,user);
		    		else
		    			main = new Main_gui(this,user);
		    		main.setVisible(true);
		    	}
		    	else if(input.equals("Invalid")){
		    		JOptionPane.showMessageDialog(login, "Invalid credentials");
		    	}
		    	else if (input.equals("Exit")){
		    		in.close();
		    		out.close();
		    		socket.close();
		    	}
		    }

		} catch (UnknownHostException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			System.out.println("IOException check_login @ serpc");
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
	
	public Login_gui getLogin_gui(){
		return this.login;
	}
	
	public JFrame getMain_gui(){
		return this.main;
	}
	
	public void setVisibility(JFrame _gui, boolean option){
		if (_gui != null)
			_gui.setVisible(option);
	}
	
	public void exit(){
		try {
			if (out != null){
				out.writeObject("Exit");
				out.close();
			}
			if (in != null)
				in.close();
			if (socket != null)
				socket.close();
			System.exit(0);
		} catch (Throwable e) {
			// TODO Auto-generated catch block
			System.out.println("exit @ Serpc");
			e.printStackTrace();
			System.exit(0);
		}
	}
	
	public static Object Query(String msg, int action){
		Object res = null;
		try {
			out.writeObject(msg);
			res = in.readObject();
			switch(action){
			case 0: break;
			case 1: out.writeObject("COMMIT");in.readObject();break;
			case 2: out.writeObject("ROLLBACK");in.readObject();break;
			}
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return res;
	}
	
	public static Object Query(String msg){
		return Query(msg,1);
	}
	
}
