package serpc.ui;

import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JMenu;
import javax.swing.JButton;
import javax.swing.GroupLayout;
import javax.swing.GroupLayout.Alignment;
import javax.swing.LayoutStyle.ComponentPlacement;
import javax.swing.JLabel;

import serpc.Serpc;

import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

public class Main_root_gui extends JFrame {

	private JPanel contentPane;
	private Serpc serpc;
	private Main_root_gui main;
	private String user;

	/**
	 * Create the frame.
	 */
	
	public Main_root_gui(final Serpc serpc, final String user) {
		addWindowListener(new WindowAdapter() {
			@Override
			public void windowClosing(WindowEvent e) {
				serpc.setVisibility(serpc.getMain_gui(), false);
				serpc.setVisibility(serpc.getLogin_gui(), false);
				serpc.exit(); 
			}
		});
		main = this;
		this.user = user;
		this.serpc = serpc;
		setTitle("SERP");
		setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
		setBounds(100, 100, 757, 575);
		
		JMenuBar menuBar = new JMenuBar();
		setJMenuBar(menuBar);
		
		JMenu mnFile = new JMenu("File");
		menuBar.add(mnFile);
		
		JMenuItem mntmLogOut = new JMenuItem("Log Out");
		mntmLogOut.addMouseListener(new MouseAdapter() {
			@Override
			public void mousePressed(MouseEvent e) {
				serpc.setVisibility(serpc.getMain_gui(), false);
				serpc.setVisibility(serpc.getLogin_gui(), true);
			}
		});
		mnFile.add(mntmLogOut);
		
		JMenuItem mntmQuit = new JMenuItem("Quit");
		mntmQuit.addMouseListener(new MouseAdapter() {
			@Override
			public void mousePressed(MouseEvent e) {
				serpc.setVisibility(serpc.getMain_gui(), false);
				serpc.setVisibility(serpc.getLogin_gui(), false);
				serpc.exit(); 
			}
		});
		mnFile.add(mntmQuit);
		
		JMenu mnConfig = new JMenu("Config");
		menuBar.add(mnConfig);
		
		JMenuItem mntmUsers = new JMenuItem("Users");
		mntmUsers.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				Users_gui users_gui = new Users_gui();
				users_gui.setVisible(true);
			}
		});
		mnConfig.add(mntmUsers);
		
		JMenuItem mntmBackuprestore = new JMenuItem("Backup/Restore");
		mntmBackuprestore.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				Backup_gui backup_gui = new Backup_gui();
				backup_gui.setVisible(true);
			}
		});
		mnConfig.add(mntmBackuprestore);
		
		JMenu mnData = new JMenu("Data");
		menuBar.add(mnData);
		
		JMenuItem mntmClients = new JMenuItem("Clients");
		mntmClients.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				Clients_gui cl_gui = new Clients_gui();
				cl_gui.setVisible(true);
			}
		});
		mnData.add(mntmClients);
		
		JMenuItem mntmItems = new JMenuItem("Products");
		mntmItems.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				Products_gui products_gui = new Products_gui();
				products_gui.setVisible(true);
			}
		});
		mnData.add(mntmItems);
		
		JMenuItem mntmSuppliers = new JMenuItem("Suppliers");
		mntmSuppliers.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				Suppliers_gui suppliers_gui = new Suppliers_gui();
				suppliers_gui.setVisible(true);
			}
		});
		mnData.add(mntmSuppliers);
		
		JMenuItem mntmDiscounts = new JMenuItem("Discounts");
		mntmDiscounts.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				Discounts_gui discounts_gui = new Discounts_gui();
				discounts_gui.setVisible(true);
			}
		});
		mnData.add(mntmDiscounts);
		
		JMenu mnSales = new JMenu("Sales");
		menuBar.add(mnSales);
		
		JMenuItem mntmBudget = new JMenuItem("Quotations");
		mntmBudget.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				Budgets_gui budgets_gui = new Budgets_gui();
				budgets_gui.setVisible(true);
			}
		});
		mnSales.add(mntmBudget);
		
		JMenuItem mntmSale = new JMenuItem("Sales");
		mntmSale.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				Sales_gui sales_gui = new Sales_gui();
				sales_gui.setVisible(true);
			}
		});
		mnSales.add(mntmSale);
		
		JMenu mnShopping = new JMenu("Purchases");
		menuBar.add(mnShopping);
		
		JMenuItem mntmBuy = new JMenuItem("Purchases");
		mntmBuy.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				Purchases_gui purchases_gui = new Purchases_gui();
				purchases_gui.setVisible(true);
			}
		});
		mnShopping.add(mntmBuy);
		
		JMenu mnHelp = new JMenu("Help");
		menuBar.add(mnHelp);
		
		JMenuItem mntmAbout = new JMenuItem("About");
		mnHelp.add(mntmAbout);
		contentPane = new JPanel();
		contentPane.setBorder(null);
		setContentPane(contentPane);
		
		JLabel lblConfig = new JLabel("Config");
		
		JLabel lblNewLabel = new JLabel("Data");
		
		JLabel lblSales = new JLabel("Sales");
		
		JLabel lblPurchases = new JLabel("Purchases");
		
		JButton btnClients = new JButton("Clients");
		btnClients.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent arg0) {
				Clients_gui cl_gui = new Clients_gui();
				cl_gui.setVisible(true);
			}
		});
		
		JButton btnProducts = new JButton("Products");
		btnProducts.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent arg0) {
				Products_gui pr_gui = new Products_gui();
				pr_gui.setVisible(true);
			}
		});
		
		JButton btnSales = new JButton("Sales");
		btnSales.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				Sales_gui sales_gui = new Sales_gui();
				sales_gui.setVisible(true);
			}
		});
		
		JButton btnBudgets = new JButton("Quotations");
		btnBudgets.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent arg0) {
				Budgets_gui bg_gui = new Budgets_gui();
				bg_gui.setVisible(true);
			}
		});
		
		JButton btnUrchases = new JButton("Purchases");
		btnUrchases.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				Purchases_gui purchases = new Purchases_gui();
				purchases.setVisible(true);
			}
		});
		
		JButton btnSuppliers = new JButton("Suppliers");
		btnSuppliers.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				Suppliers_gui supp_gui = new Suppliers_gui();
				supp_gui.setVisible(true);
			}
		});
		
		JButton btnUsers = new JButton("Users");
		btnUsers.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if (user.equals("root")){
					Users_gui users_gui = new Users_gui();
					users_gui.setVisible(true);
				}
				else
					JOptionPane.showMessageDialog(null, "Error: Only administrator can access user management.");
			}
		});
		
		JButton btnBackuprestore = new JButton("Backup/Restore");
		btnBackuprestore.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				Backup_gui backup_gui = new Backup_gui();
				backup_gui.setVisible(true);
			}
		});
		
		JButton btnDiscounts = new JButton("Discounts");
		btnDiscounts.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				Discounts_gui discounts_gui = new Discounts_gui();
				discounts_gui.setVisible(true);
			}
		});
		GroupLayout gl_contentPane = new GroupLayout(contentPane);
		gl_contentPane.setHorizontalGroup(
			gl_contentPane.createParallelGroup(Alignment.LEADING)
				.addGroup(gl_contentPane.createSequentialGroup()
					.addGap(52)
					.addComponent(lblConfig)
					.addGap(149)
					.addComponent(lblNewLabel)
					.addPreferredGap(ComponentPlacement.RELATED, 153, Short.MAX_VALUE)
					.addComponent(lblSales)
					.addGap(126)
					.addComponent(lblPurchases)
					.addGap(104))
				.addGroup(gl_contentPane.createSequentialGroup()
					.addGap(39)
					.addGroup(gl_contentPane.createParallelGroup(Alignment.LEADING)
						.addComponent(btnUsers)
						.addComponent(btnBackuprestore))
					.addGap(46)
					.addGroup(gl_contentPane.createParallelGroup(Alignment.LEADING)
						.addGroup(gl_contentPane.createSequentialGroup()
							.addComponent(btnDiscounts)
							.addContainerGap())
						.addGroup(gl_contentPane.createSequentialGroup()
							.addGroup(gl_contentPane.createParallelGroup(Alignment.LEADING)
								.addComponent(btnProducts)
								.addComponent(btnClients)
								.addComponent(btnSuppliers))
							.addGap(103)
							.addGroup(gl_contentPane.createParallelGroup(Alignment.LEADING)
								.addComponent(btnBudgets)
								.addComponent(btnSales))
							.addPreferredGap(ComponentPlacement.RELATED, 55, Short.MAX_VALUE)
							.addComponent(btnUrchases)
							.addGap(81))))
		);
		gl_contentPane.setVerticalGroup(
			gl_contentPane.createParallelGroup(Alignment.LEADING)
				.addGroup(gl_contentPane.createSequentialGroup()
					.addGap(64)
					.addGroup(gl_contentPane.createParallelGroup(Alignment.BASELINE)
						.addComponent(lblConfig)
						.addComponent(lblPurchases)
						.addComponent(lblSales)
						.addComponent(lblNewLabel))
					.addGap(30)
					.addGroup(gl_contentPane.createParallelGroup(Alignment.LEADING)
						.addComponent(btnUsers)
						.addGroup(gl_contentPane.createSequentialGroup()
							.addComponent(btnBudgets)
							.addGap(32)
							.addGroup(gl_contentPane.createParallelGroup(Alignment.BASELINE)
								.addComponent(btnSales)
								.addComponent(btnBackuprestore)))
						.addComponent(btnUrchases)
						.addGroup(gl_contentPane.createSequentialGroup()
							.addComponent(btnClients)
							.addGap(32)
							.addComponent(btnProducts)
							.addGap(29)
							.addComponent(btnSuppliers)))
					.addGap(18)
					.addComponent(btnDiscounts)
					.addContainerGap(239, Short.MAX_VALUE))
		);
		contentPane.setLayout(gl_contentPane);
	}
	
	public Serpc getSerpc(){
		return this.serpc;
	}
}
